#ifndef HIDINTERFACE_H
#define HIDINTERFACE_H

#include <QObject>
#include <QThread>

struct HIDInterface_t;

class HidInterface : public QThread
{
    Q_OBJECT

public:
    HidInterface(quint16 vendorId, quint16 productId, uint endpoint, QObject* parent = 0);
    virtual ~HidInterface();

    bool open();
    void close();

    bool write ( const QByteArray& data );

signals:
    void connectionLost ( );
    void readData( QByteArray data );

protected:
    virtual void run ();

private:
    static int   getInputReportSize ( uchar reportId );
    static bool  getOutputReportId ( int dataSize, uchar &reportId, int &reportSize );

private:
    quint16             m_vendorId;
    quint16             m_productId;
    uint                m_endpoint;

    bool                m_active;
    bool                m_open;
    HIDInterface_t*     m_hidInterface;
};

#endif // HIDINTERFACE_H
