#ifndef TCPINTERFACE_H
#define TCPINTERFACE_H

#include <QThread>
#include <QTcpSocket>
#include <QMutex>
#include <QBuffer>

class Bridge;

class TcpInterface : public QThread
{
    Q_OBJECT
public:
    TcpInterface(QTcpSocket* socket, Bridge* bridge, QObject *parent = 0);

protected:
    virtual void run ();

private slots:
    void readFromDevice();
    void writeToDevice();

private:
    void parsePackage( const QByteArray& package);

private:
    QTcpSocket*     m_socket;
    Bridge*         m_bridge;
};

#endif // TCPINTERFACE_H
